# The Architecture in Detail
The following chapters will discuss the core objects and classes of our application structure.

## General and principles

* [Overview](./overview.md)
* [Getting started](./getting_started.md)
* [Event Handling Overview](./events.md)
* [Disposal](./disposal.md)
* [Handling Asynchronous Dependencies](./handling_async.md)

## API docs

### Core
* [Mediator](./chaplin.mediator.md)
* [Dispatcher](./chaplin.dispatcher.md)
* [Application](./chaplin.application.md)

### MVC
* [Controller](./chaplin.controller.md)
* [Model](./chaplin.model.md)
* [Collection](./chaplin.collection.md)
* [Layout](./chaplin.layout.md)
* [View](./chaplin.view.md)
* [Collection View](./chaplin.collection_view.md)

### Libs
* [EventBroker](./chaplin.event_broker.md)
* [SyncMachine](./chaplin.sync_machine.md)
* [Router](./chaplin.router.md)
* [Route](./chaplin.route.md)
* [Support](./chaplin.support.md)
* [Utils](./chaplin.utils.md)
